//Verschiedene Farbverläufe mit 1024 Farben
//Mit den Tasten '0'....'6' kann man sie sich anschauen
FarbTafel1024 farben;
color[] zufallsAnkerFarben16;
color[] semiZufallsAnkerFarben16;
color[] zufallsAnkerFarben4;

void setup(){
  size(1024,200);
  farben= new FarbTafel1024();
  farben.farbTafelErzeugen1024();  
  setFarbVerlauf16(farben.farben1024Fest16);
  zufallsAnkerFarben16 = new color[17];
  semiZufallsAnkerFarben16 = new color[17];
  zufallsAnkerFarben4 = new color[5];
}
///////////////////////////////////////////////////////////////
void draw() {

}
//////////////////////////////////////////////////////////////////
void setFarbVerlauf16(color[] farbTafel){//Farbtafel zeichnen
  for (int i = 0; i < 1024; i++) {     
      if(i % 64 !=0) stroke(farbTafel[i]);
      else stroke(255);//weiße Striche zu Kontrolle      
      line(i, 0, i, height);  
  }
}
void setFarbVerlauf4(color[] farbTafel){//Farbtafel zeichnen
  for (int i = 0; i < 1024; i++) {     
      if(i % 256 !=0) stroke(farbTafel[i]);
      else stroke(255);//weiße Striche zu Kontrolle      
      line(i, 0, i, height);  
  }
}
////////////////////////////////////////////////////////////////////
void mousePressed() { 
  if (mouseButton == LEFT){    
    //für weitere Aktionen
  }
}
////////////////////////////////////////////////////////////////////////
void keyPressed() {
  
  if (key == '0'){ //eher dunkel blau-grün
    setFarbVerlauf16(farben.farben1024Fest16);
  }
  if (key == '1'){ //einige Anker-Farben sind fest vorgegeben - die anderen sind zufällig
    farben.farbTafelErzeugen1024();  
    setFarbVerlauf16(farben.farben1024SemiZufall16);
    semiZufallsAnkerFarben16 = farben.semiZufallsFarbenHolen16();
    println("Ankerfarben bei farben1024SemiZufall16: ");
    for(int j=0; j<17;j++){
      println((int)red(semiZufallsAnkerFarben16[j]),(int)green(semiZufallsAnkerFarben16[j]), (int)blue(semiZufallsAnkerFarben16[j]) );
    }   
  }
  if (key == '2'){ //feste bunte Ankerfarben
    setFarbVerlauf16(farben.farben1024Fest16Bunt);
  }
  if (key == '3'){ //zufällige Ankerfarben- aber geringe Änderungen von einer zu nächsten
    farben.farbTafelErzeugen1024(); 
    setFarbVerlauf16(farben.farben1024Zufall16);
    zufallsAnkerFarben16 = farben.zufallsFarbenHolen16();
    println("Ankerfarben bei farben1024Zufall16: ");
    for(int j=0; j<17;j++){
       println((int)red(zufallsAnkerFarben16[j]),(int)green(zufallsAnkerFarben16[j]), (int)blue(zufallsAnkerFarben16[j]) );
    }
  }
  if (key == '4'){ //fest rot-gelb-rot Farbverlauf
    setFarbVerlauf16(farben.farben1024Fest16RotGelb);
  }
  if (key == '5'){//nur fünf Ankerfarben grau-cyan 
    setFarbVerlauf4(farben.farben1024Fest4GrauCyan);
  }
  if (key == '6'){  // fünf zufällige Ankerfarben- aber geringe Änderungen von einer zu nächsten
    farben.farbTafelErzeugen1024(); 
    setFarbVerlauf4(farben.farben1024Zufall4);
    zufallsAnkerFarben4 = farben.zufallsFarbenHolen4();
    println("Ankerfarben bei farben1024Zufall4: ");
    for(int j=0; j<5;j++){
       println((int)red(zufallsAnkerFarben4[j]),(int)green(zufallsAnkerFarben4[j]), (int)blue(zufallsAnkerFarben4[j]) );
    }
  }
  
}
